// IMediaDecoder.h: IMediaDecoder NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(_IMEDIADECODER_H_)
#define _IMEDIADECODER_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "MediaData.h"


class IMediaDecoder  
{
public:
	IMediaDecoder();
	virtual ~IMediaDecoder();

	virtual void Reset(void);

	virtual const DWORD GetInputNum(void) const = 0;
	virtual const DWORD GetOutputNum(void) const = 0;

	virtual const bool SetOutputDecoder(IMediaDecoder *pDecoder, const DWORD dwOutputIndex = 0, const DWORD dwInputIndex = 0);
	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0) = 0;

protected:
	// o̓sf[^x[X
	struct TAG_OUTPUTDECODER
	{
		IMediaDecoder *pDecoder;
		DWORD dwInputIndex;
	} m_aOutputDecoder[16];

	// NeBJZNV
	class CLockObject
	{
	public:
		CLockObject();
		~CLockObject();
	
		void Lock(void);
		void Unlock(void);
	
	private:
		CRITICAL_SECTION m_CriticalSection;
	};

	// ubNbN
	class CLockBlock
	{
	public:
		CLockBlock(CLockObject *pLockObject);
		~CLockBlock();
		
	private:
		CLockObject *m_pLockObject;
	};

	virtual const bool OutputMedia(CMediaData *pMediaData, const DWORD dwOutptIndex = 0);
};

#endif // !defined(_IMEDIADECODER_H_)
